//BUSQUEDA DE TABCATMED
var formaTABCATMED = null;
var panelTABCATMED = null;
var intMode = 100;
var idTienda = null, idProveedor=null;
var GridStoreTABCATMED = null;
var email = "";

function TABCATMED_Constructor(){
	idTab = 'TABCATMED';
	
	var txtBoton = "";
		
	panelTABCATMED = new Ext.Panel({
						width:'100%',
						height: '80%',
						autoScroll:false,
						disabled: false
	});
	
	formaTABCATMED = new Ext.FormPanel({
		labelAlign: 'top',
        labelWidth: 75,
        frame:true,
		bodyStyle:'padding:5px 5px 0',
        width: '100%',
		autoHeight: true,
        items: [
				panelTABCATMED
			   ]
    });
	
	$("#divCatMedicamentos").empty();
	formaTABCATMED.render("divCatMedicamentos");

	panelTABCATMED.load({
		url: "vistas/tabCatMedicamentos.php",
		params: {intMode:0, campo:'', order:''}, // or a URL encoded string
		callback: function(data){   
						
			$("#btnInsertar" + idTab).click(function() {
				AddEditTABCATMED(1);
			});
				
			llenarCombo("laboratorios", $( "#divFiltrosMedicamentos" ).find( "#selectBusLab" ), objUsuario.empresa, '', null);
	
			getDataTABCATMED(1, 'a');
						
		},
		discardUrl: false,
		nocache: false,
		text: 'Loading...',
		timeout: 30,
		scripts: false
	});
}

/*function cargarTipoUsuarios(selObj){
	var strUrl1 = "data/comboboxes.php?method=tiposusuarios&intEmpresa="+ objUsuario.empresa +"&rnd="+ Math.random();
	
	$.get(strUrl1, function(dataNew){
		var data = $.parseJSON(dataNew);
		var arrProductosCategorias = data.Items;
		
		selObj.empty();
		for (var i=0; i<arrProductosCategorias.length; i++) {
		  selObj.append('<option value="' + arrProductosCategorias[i].id + '">' + arrProductosCategorias[i].label + '</option>');
		}
		
	});
}*/

function getDataTABCATMED(intCase, strLetra){
		
	if(objUsuario.empresa!=null){
		
		$( "#divMedicamentosGrid" ).html("<div style='width:200px; margin-top:25px; margin-left:auto; margin-right:auto;'><img src='css/images/loading.gif'/></div>");
		
		//"http://root.menu-digital.com.mx/expediente-clinico2/code/data/catMedicamentos.php?intEmpresa="+ objUsuario.empresa +"&method=consultar&rnd="+ Math.random()
		var strUrl = "data/catMedicamentos.php?intEmpresa="+ objUsuario.empresa +"&intCase="+ intCase +"&method=consultar&rnd="+ Math.random();
		if(strLetra!=null){
			strUrl += "&strLetra="+ strLetra;
		}
		
		GridStoreTABCATMED = new Ext.data.JsonStore({
			root: 'Items',
			totalProperty: 'totalCount',
			idProperty: 'intMedicamento',
			remoteSort: false,
			fields: [ 'intMedicamento', 'strMedicamento', 'strSustancia', 'strForma', 'strPresentacion', 'strLaboratorio', 'datFechaAlta', 'intFavorito' ],
			// load using script tags for cross domain, if the data in on the same domain as
			// this page, an HttpProxy would be better (ScriptTagProxy)
			proxy: new Ext.data.HttpProxy({
				url: strUrl
			})
		});
	
		$( "#divMedicamentosGrid" ).html("");
		
		var heightDoc = $(document).height();
		console.log("heightDoc: "+ heightDoc);
		heightDoc = heightDoc - 140;

		var grid = new Ext.grid.GridPanel({
			renderTo: document.getElementById("divMedicamentosGrid"),
			frame: true,
			title: 'Medicamentos',
			width:'100%',
			height: heightDoc,
			store: GridStoreTABCATMED,
			trackMouseOver:false,
			disableSelection:true,
			loadMask: true,
			columns: [
			  {header: "Id", width: 60, dataIndex: 'intMedicamento', sortable: true},
			  {header: "Medicamento", width: 200, dataIndex: 'strMedicamento', sortable: true, 
				renderer: function (value, metaDat, record) {
					var newValue = "<a href='javascript: AddEditTABCATMED(2,"+ record.data["intMedicamento"] +");' target='_blank' style='color:#C60;'>"+ value +"</a>";
					return newValue;
				} 
			  },
			  {header: "Sustancia", width: 220, dataIndex: 'strSustancia', sortable: true},
			  {header: "Forma", width: 80, dataIndex: 'strForma', sortable: true},
			  {header: "Presentacion", width: 250, dataIndex: 'strPresentacion', sortable: true},
			  {header: "Laboratorio", width: 120, dataIndex: 'strLaboratorio', sortable: true},
			  {header: "Favorito", width: 80, dataIndex: 'intFavorito', sortable: true, 
				renderer: function (value, metaDat, record) {
					if(value==0){
						var newValue = "<a href='javascript: setFavoritoMed("+ record.data["intMedicamento"] +", 1);' target='_blank' style='color:#C60;'><img src='images/estrellitaOff.png'></a>";
					}else if(value==1){
						var newValue = "<a href='javascript: setFavoritoMed("+ record.data["intMedicamento"] +", 0);' target='_blank' style='color:#C60;'><img src='images/estrellitaOn.png'></a>";
					}
					return newValue;
				}
			  }
			],
			bbar: new Ext.PagingToolbar({
				pageSize: 20,
				store: GridStoreTABCATMED,
				displayInfo: true,
				displayMsg: 'Mostrando {0} - {1} of {2}',
				emptyMsg: "0 Registros que mostrar"
				/*,items:[
					'-', {
					pressed: true,
					enableToggle:true,
					text: 'Ver Preview',
					cls: 'x-btn-text-icon details',
					toggleHandler: function(btn, pressed){
						var view = grid.getView();
						view.showPreview = pressed;
						view.refresh();
					}
				}]*/
			})
		});
		
		// trigger the data store load
		GridStoreTABCATMED.load({params:{start:0, limit:20}});


	}else{
		alert("Todos los campos son requeridos");
	}
}

function limpiarTextboxesTABCATMED(){

	$( "#dialog-medicamento" ).find( "#txtIntMedicamento" ).val('');
	$( "#dialog-medicamento" ).find( "#txtMedicamento" ).val('');
	$( "#dialog-medicamento" ).find( "#txtSustancia" ).val('');
	$( "#dialog-medicamento" ).find( "#selectForma" ).val('');
	$( "#dialog-medicamento" ).find( "#txtPresentacion" ).val('');
	$( "#dialog-medicamento" ).find( "#selectLaboratorio" ).val('');
	//$( "#dialog-medicamento" ).find( "#imgFavorito" ).val('');

}

function AddEditTABCATMED(intCase, id){
	$( "#divLoading" ).css({ "visibility":"visible", "display":"inherit" });
	var strUrl1 = "vistas/dialog-medicamento.php?rnd="+ Math.random();
	
	$.get(strUrl1, function(data){
		
		$("#divCatMedicamentos").html(data);					
		
		/*cargarTipoUsuarios($( "#dialog-medicamento" ).find("#selectTipoUsuario"));*/
		llenarCombo("formas", $( "#dialog-medicamento" ).find( "#selectForma" ), objUsuario.empresa, '', null);
		
		llenarCombo("laboratorios", $( "#dialog-medicamento" ).find( "#selectLaboratorio" ), objUsuario.empresa, '', null);
															  		
		setTimeout(function(){ cargarDataDialogTABCATMED(intCase, id); }, 1000);
	});
}

function muestra_oculta(id){
	var combo = $( "#dialog-medicamento" ).find( "#selectTipoUsuario" ).val();
		if(combo == 1 && document.getElementById){ //se obtiene el id
		var el = document.getElementById(id); //se define la variable "el" igual a nuestro div
		el.style.display = (el.style.display == 'none') ? 'block' : 'none'; //damos un atributo display:none que oculta el div
		}
		}
		window.onload = function(){/*hace que se cargue la función lo que predetermina que div estará oculto hasta llamar a la función nuevamente*/
		muestra_oculta('nombreConsul');/* "contenido_a_mostrar" es el nombre que le dimos al DIV */
}

function cargarDataDialogTABCATMED(intCase, id){
	
	$( "#btnGuardar" + idTab).unbind( "click" );
	$( "#btnCancelar" + idTab).unbind( "click" );
	$( "#btnEliminar" + idTab).unbind( "click" );
		
	if(intCase===1){
		
		limpiarTextboxesTABCATMED();

		$( "#btnGuardar" + idTab ).click(function() {
			abcTABCATMED(1);
		});
		
		$( "#btnCancelar" + idTab ).click(function() {
			TABCATMED_Constructor();
		});
		
		$( "#btnEliminar" + idTab ).css({ visibility:"hidden" });
				
	}else{
		
		var record = null;

		GridStoreTABCATMED.each(function(rd){  // REGRESA EL NOMBRE DE USUARIO
			if( parseInt(id) == parseInt(rd.data["intMedicamento"]) ){
				record = rd;
			}
		});

		if(record != null){
			$( "#dialog-medicamento" ).find( "#txtIntMedicamento" ).val(record.data["intMedicamento"]);
			$( "#dialog-medicamento" ).find( "#txtMedicamento" ).val(record.data["strMedicamento"]);
			$( "#dialog-medicamento" ).find( "#txtSustancia" ).val(record.data["strSustancia"]);
			$( "#dialog-medicamento" ).find( "#selectForma" ).val(record.data["strForma"]);
			$( "#dialog-medicamento" ).find( "#txtPresentacion" ).val(record.data["strPresentacion"]);
			$( "#dialog-medicamento" ).find( "#selectLaboratorio" ).val(record.data["strLaboratorio"]);
			
			if( parseInt(record.data["intFavorito"])==0 ){
				$( "#dialog-medicamento" ).find( "#imgFavorito" ).prop("src", "images/estrellitaOff.png");
				$( "#dialog-medicamento" ).find( "#intFavorito" ).val(0);
			}else if( parseInt(record.data["intFavorito"])==1 ){
				$( "#dialog-medicamento" ).find( "#imgFavorito" ).prop("src", "images/estrellitaOn.png");
				$( "#dialog-medicamento" ).find( "#intFavorito" ).val(1);
			}
			$( "#btnGuardar"  + idTab).click(function() {
				abcTABCATMED(2);
			});
			
			$( "#btnCancelar" + idTab ).click(function() {
				TABCATMED_Constructor();
			});
			
			$( "#btnEliminar" + idTab).css({ visibility:"visible" });
			$( "#btnEliminar" + idTab).click(function() {
				abcTABCATMED(3);
			});
				
		}
	}
	$( "#divLoading" ).css({ "visibility":"hidden", "display":"none" });
}

function pagoOnChange(sel) {
      if (sel.value=="Doctor"){
           divC = document.getElementById("nombreConsul");
           divC.style.display = "";

      }else{

           divC = document.getElementById("nombreConsul");
           divC.style.display="none";
      }
}
/*function validarEmail( email ) {
    expr = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
    if ( !expr.test(email) )
        alert("Error: La dirección de correo " + email + " es incorrecta.");
}*/

function abcTABCATMED(intCase){
			
	if($( "#dialog-medicamento" ).find( "#txtMedicamento" ).val() != "" && $( "#dialog-medicamento" ).find( "#txtSustancia" ).val() != ""
			&& $( "#dialog-medicamento" ).find( "#selectForma" ).val() != "" && $( "#dialog-medicamento" ).find( "#txtPresentacion" ).val() != ""
			&& $( "#dialog-medicamento" ).find( "#selectLaboratorio" ).val() != ""){
			
			var sQuery = "data/catMedicamentos.php?method=modificar&intMode="+ intCase 
			+"&intMedicamento="+ $( "#dialog-medicamento" ).find( "#txtIntMedicamento" ).val()
			+"&txtMedicamento="+ encodeURIComponent( $( "#dialog-medicamento" ).find( "#txtMedicamento" ).val() )
			+"&txtSustancia="+ encodeURIComponent( $( "#dialog-medicamento" ).find( "#txtSustancia" ).val() )
			+"&selectForma="+ encodeURIComponent( $( "#dialog-medicamento" ).find( "#selectForma" ).val() )
			+"&txtPresentacion="+ encodeURIComponent( $( "#dialog-medicamento" ).find( "#txtPresentacion" ).val() )
			+"&selectLaboratorio="+ encodeURIComponent( $( "#dialog-medicamento" ).find( "#selectLaboratorio" ).val() ) 
			+"&intFavorito="+ $( "#dialog-medicamento" ).find( "#intFavorito" ).val() 
			+"&intEmpresa="+ objUsuario.empresa +"&rnd="+ Math.random();

			console.log(sQuery);
			
			$.post(sQuery, function(dataNew){
				
				TABCATMED_Constructor();
	
			});
			
		}else{
			alert("Todos los campos son requeridos.");
		}
}

function buscarPorSustancia(strTermino){
	if(strTermino==""){
		getDataTABCATMED(1, 'A');
	}else{
		getDataTABCATMED(2, strTermino);
	}
}

function buscarPorLaboratorio(strTermino){
	$( "#divFiltrosMedicamentos" ).find( "#txtBusMed" ).val('');
	if(strTermino=="a"){
		getDataTABCATMED(1, strTermino);
	}else{
		getDataTABCATMED(3, strTermino);
	}
}

function setFavoritoMed(intMedicamento, intFavorito){
	var sQuery = "data/catMedicamentos.php?method=modificar&intMode=4&intMedicamento="+ intMedicamento 
	+"&intFavorito="+ intFavorito
	+"&intEmpresa="+ objUsuario.empresa +"&rnd="+ Math.random();
	
	console.log(sQuery);
	
	$.post(sQuery, function(dataNew){
		
		TABCATMED_Constructor();

	});
}

function changeFavoritoMed(){
	var intFavorito = $( "#dialog-medicamento" ).find( "#intFavorito" ).val();
	if(intFavorito==0){
		$( "#dialog-medicamento" ).find( "#imgFavorito" ).prop("src", "images/estrellitaOn.png");
		$( "#dialog-medicamento" ).find( "#intFavorito" ).val(1);
	}else if(intFavorito==1){
		$( "#dialog-medicamento" ).find( "#imgFavorito" ).prop("src", "images/estrellitaOff.png");
		$( "#dialog-medicamento" ).find( "#intFavorito" ).val(0);
	}
}
